﻿using System;
using System.Collections.ObjectModel;
using System.Windows.Controls;
using System.Windows.Data;
using Telerik.Windows.Controls;

namespace ValueConverter_1 {
    public partial class MainPage : UserControl {
        public MainPage() {
            InitializeComponent();
            AddColumns();
            _dg.ItemsSource = GetItems();
        }

        private void AddColumns() {
            _dg.AutoGenerateColumns = false;
            _dg.Columns.Add(CreateColumn(typeof(string), "Name"));
            _dg.Columns.Add(CreateColumn(typeof(float), "Amount"));
        }

        private static GridViewDataColumn CreateColumn(Type columnType, string dataPath) {
            GridViewDataColumn col = new GridViewDataColumn();
            col.DataType = columnType;

            col.DataMemberBinding = new Binding(dataPath);
            
            // Using this will have the edit mode with raw numbers.
            col.DataFormatString = "{0:C}";
            
            // Using this will have the edit mode take the converter into account
            // so you will need to rewrite the ConvertBack method to parse the
            // money string and return a double. We suggest using the DataFormatString instead.
            //if (col.DataType == typeof(float))
            //{
            //    col.DataMemberBinding.Converter = new FloatToMoneyConverter();                
            //}


            col.Header = dataPath;
            return col;
        }


        private ObservableCollection<Item> GetItems() {
            ObservableCollection<Item> items = new ObservableCollection<Item>();
            items.Add(new Item() { Name = String.Format("Item 1"), Amount = 19.99f });
            items.Add(new Item() { Name = String.Format("Item 2"), Amount = 29.99f });
            items.Add(new Item() { Name = String.Format("Item 3"), Amount = 39.99f });
            items.Add(new Item() { Name = String.Format("Item 4"), Amount = 49.99f });
            items.Add(new Item() { Name = String.Format("Item 5"), Amount = 59.99f });
            return items;
        }

        //private void _dg_DataLoaded(object sender, EventArgs e) {
        //    for (int x = 0; x < _dg.Columns.Count; x++) {
        //        if (( ((GridViewDataColumn)_dg.Columns[x]).DataType == typeof(float))) {
        //            GridViewDataColumn gvdc = (GridViewDataColumn)_dg.Columns[x];
        //            if (gvdc.DataMemberBinding.Converter == null) {
        //                gvdc.DataMemberBinding.Converter = new FloatToMoneyConverter();
        //            }
        //        }
        //    }
        //}
    }

    //public class FloatToMoneyConverter : IValueConverter {

    //    public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture) {
    //        double val = System.Convert.ToDouble(value);
    //        string fval = String.Format("{0:C}", val);
    //        return fval;
    //    }


    //    public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture) {
    //        return System.Convert.ToDouble(value);
    //    }
    //}

    public class Item {
        public Item() {
            Amount = 0.00f;
            Name = null;
        }
        public float Amount { get; set; }
        public string Name { get; set; }

    }
}
